var m_map;
var f_map;

function startUp() {

  // 動かせる方の地図
  // 初期位置はとりあえず適当に決めておく
  m_map = new GMap2( document.getElementById("movable_map") );
  m_map.setCenter( new GLatLng(35.6984, 139.7732), 13 );
  m_map.addControl(new GSmallMapControl());
  m_map.addControl(new GMapTypeControl());

  // 固定する方の地図（衛星写真モード）
  // disableDraggingで、ドラッグスクロールを禁止
  // コントロールも当然何も付け加えない
  f_map = new GMap2( document.getElementById("fixed_map") );
  f_map.setCenter( new GLatLng(35.6984, 139.7732), 13 );
  f_map.setMapType( G_SATELLITE_MAP );
  f_map.disableDragging();

  // 最初のレベルをロード
  loadLevel(1);
}

function loadLevel(lv) {
  // levelsフォルダから指定レベルのデータをダウンロード
  GDownloadUrl( "levels/"+lv+".dat", startLevel );

  // ダウンロード完了イベントで、ゲームスタート
  function startLevel(data, status) {
    if( status != 200 ) {
      // もう面データがサーバから取得できなかったら、
      // 全面クリアと判定することにする
      alert( "全面クリアおめでとうございます！" );
      return;
    }

    // データがサーバから取得できたら、JSONからオブジェクトに変換
    var problem = data.parseJSON();

    // ヒント表示
    document.getElementById("hint").innerHTML = problem.hint;

    // 固定地図の表示範囲を変更
    var f_center = new GLatLng(problem.lat, problem.lng);
    f_map.setCenter( f_center, problem.zoom );

    // 動かせる地図を動かしたときの、クリア判定
    GEvent.addListener( m_map, "moveend", function(){
      // 固定地図とのズレが200m以内ならOKということにする
      var m_center = m_map.getCenter();
      if( m_center.distanceFrom(f_center) < 200 )
        clearLevel();
    });
  }

  // ひとレベルクリアした時の処理
  function clearLevel() {
     alert( "レベル "+lv+" クリア！" );

     // 前の面のクリア判定をイベント処理から外す
     GEvent.clearListeners( m_map, "moveend" );

     // 次のレベル
     loadLevel(lv+1);
   }
}

// いつもの
onload   = startUp;
onunload = GUnload;
