var map;

function startUp() {
  map = new GMap2( document.getElementById("mymap") );
  map.setCenter( new GLatLng(35.6984, 139.7732), 13 );
  map.addControl(new GSmallMapControl());
  map.addControl(new GMapTypeControl());

  GEvent.addListener(map, "click", addHistory);
}

var prevPos;     // 前回addHistoryされた位置
var counter = 1; // 何回目のaddHistoryか？

function addHistory(ov, latlng) {
  // ※ マーカーがクリックされたときであっても、
  //    地図に登録したイベント処理関数も呼び出されてしまう。
  //  直接地図をクリックしたときは変数 ov は null、
  //  マーカーをクリックしたときは ov にそのマーカーが入っているので、
  //  直接地図クリックのみを処理したいときは、ovに何か入っていたら
  //  すぐにreturnする。
  if( ov )
    return;
  var posLink = createPositionLink();
  var distStr = calcDistanceString();
  var newItem = addListItem( posLink, distStr );
  addMarker();

  // ユーティリティ：小数点以下３桁で切り捨て
  function shortForm(x) {
    return Math.floor(x*1000)/1000;
  }

  // サブルーチン：緯度経度の文字列と、クリックイベント処理を準備
  function createPositionLink() {
    var posLink = document.createElement("a");
    posLink.innerHTML =
      "(" + shortForm(latlng.lat()) + "," + shortForm(latlng.lng()) + ")";
    posLink.href = "#";
    posLink.onclick = function() { map.panTo(latlng); }
    return posLink;
  }

  // サブルーチン：距離を文字列表記
  function calcDistanceString() {
    var str;
    if( prevPos == undefined )
      str = "?";
    else
      str = shortForm( latlng.distanceFrom(prevPos) ) + "m";

    prevPos = latlng;
    return str;
  }

  // サブルーチン：リスト項目を追加
  function addListItem( pl, ds ) {
    var newLi = document.createElement("li");
    var distText = document.createTextNode(" - " + ds);
    newLi.appendChild(pl);
    newLi.appendChild(distText);

    var historyList = document.getElementById("history");
    historyList.appendChild(newLi);
    return newLi;
  }

  // サブルーチン：マーカー追加
  function addMarker() {
    var mk = new GMarker(latlng);
    map.addOverlay(mk);
  }
}

onload   = startUp;
onunload = GUnload;
