var map;

function startUp() {
  map = new GMap2( document.getElementById("mymap") );
  map.setCenter( new GLatLng(35.6984, 139.7732), 13 );
  map.addControl(new GSmallMapControl());
  map.addControl(new GMapTypeControl());

  GEvent.addListener(map, "click", addHistory);
}

var prevPos;     // 前回addHistoryされた位置
var counter = 1; // 何回目のaddHistoryか？

function addHistory(ov, latlng) {
  if( ov )
    return;

  var posLink = createPositionLink();
  var distStr = calcDistanceString();
  var newItem = addListItem( posLink, distStr );
  addMarker();

  // ユーティリティ：小数点以下３桁で切り捨て
  function shortForm(x) {
    return Math.floor(x*1000)/1000;
  }

  // サブルーチン：緯度経度の文字列と、クリックイベント処理を準備
  function createPositionLink() {
    var posLink = document.createElement("a");
    posLink.innerHTML =
      "(" + shortForm(latlng.lat()) + "," + shortForm(latlng.lng()) + ")";
    posLink.href = "#";
    posLink.onclick = function() { map.panTo(latlng); }
    return posLink;
  }

  // サブルーチン：距離を文字列表記
  function calcDistanceString() {
    var str;
    if( prevPos == undefined )
      str = "?";
    else
      str = shortForm( latlng.distanceFrom(prevPos) ) + "m";

    prevPos = latlng;
    return str;
  }

  // サブルーチン：リスト項目を追加
  function addListItem( pl, ds ) {
    var newLi = document.createElement("li");
    var distText = document.createTextNode(" - " + ds);
    newLi.appendChild(pl);
    newLi.appendChild(distText);

    var historyList = document.getElementById("history");
    historyList.appendChild(newLi);
    return newLi;
  }

  // サブルーチン：マーカー追加
  function addMarker() {
    var icon = new GIcon();
    icon.image      = "markers/marker"+counter+".png";         // マーカー画像
    icon.iconSize   = new GSize(20, 34);                       // マーカーサイズ
    icon.shadow     = "http://www.google.com/mapfiles/shadow50.png"; // 影画像
    icon.shadowSize = new GSize(37, 34);                             // 影サイズ
    icon.iconAnchor = new GPoint(10, 34); // 画像のどの位置を座標latlngに置くか
    counter ++;
  
    var mk = new GMarker(latlng, icon);
    map.addOverlay(mk);
  }
}

onload   = startUp;
onunload = GUnload;
