var map;

function startUp() {
  map = new GMap2( document.getElementById("mymap") );
  map.setCenter( new GLatLng(35.6984, 139.7732), 13 );
  map.addControl(new GSmallMapControl());
  map.addControl(new GMapTypeControl());

  var pm = new PositionMark(new GLatLng(35.6984, 139.7732));
  map.addOverlay( pm );
}

function PositionMark(latlng) {
  this.pos_ = latlng;
}

PositionMark.prototype = new GControl();

PositionMark.prototype.initialize = function(map) {
  this.box_ = document.createElement("div");
  this.box_.style.position        = "absolute";
  this.box_.style.width           = "7em";
  this.box_.style.backgroundColor = "white";
  this.box_.style.color           = "black";
  this.box_.style.fontSize        = "smaller";
  this.box_.style.border          = "1px solid black"; 
  this.box_.style.padding         = "1px 6px";
  map.getPane(G_MAP_MAP_PANE).appendChild(this.box_);
  this.map_ = map;
}

PositionMark.prototype.redraw = function(force) {
  if(!force) return;

  var c1 = this.map_.fromLatLngToDivPixel(this.pos_);
  this.box_.style.left = c1.x + "px";
  this.box_.style.top  = c1.y + "px";

  function shortForm(x) { return Math.floor(x*1000)/1000; }
  this.box_.innerHTML =  "(" + shortForm(this.pos_.lat()) 
                      + ", " + shortForm(this.pos_.lng()) + ")";
}

PositionMark.prototype.copy = function() {
  return new PositionMark(this.pos_);          // 自分をコピー
}

PositionMark.prototype.remove = function() {
  this.box_.parentNode.removeChild(this.box_); // 自分をDOMで親から削除
}

onload   = startUp;
onunload = GUnload;
