var map;

function startUp() {
  map = new GMap2( document.getElementById("mymap") );
  map.setCenter( new GLatLng(35.6984, 139.7732), 13 );
  map.addControl(new GSmallMapControl());
  map.addControl(new GMapTypeControl());

  // list.phpでマーカーの一覧を取得(GET)
  GDownloadUrl( "list.php", function(listdata){
    var markers = listdata.parseJSON();
    if(markers)
      for(var i=0; i<markers.length; ++i) { // それぞれについて…
        var markerID = markers[i];
        // read.phpでマーカー情報を取得(GET)
        GDownloadUrl( "read.php?id=" + encodeURIComponent(markerID), function(mkdata){
          // 地図にマーカーを追加
          var mk = mkdata.parseJSON();
          addEditableMarker( mk.id, new GLatLng(mk.lat, mk.lng), mk.data );
        });
      }
    });

  // クリック時もマーカー追加処理
  GEvent.addListener( map, "click", function(ov,latlng){
    if( ov )
      return;
    addEditableMarker( undefined, latlng, "<p>なにか書いてね</p>" );
  })
}

function PostUrl( url, data, handler ) {
  // POST用のXMLHttpRequestオブジェクトを作成
  var req = GXmlHttp.create();
  req.open( "POST", url, true );
  // 通常のフォームからのPOSTとヘッダを揃える
  req.setRequestHeader( "content-type",
     "application/x-www-form-urlencoded;charset=utf-8" );
  // 結果受信時の処理
  req.onreadystatechange = function() {
    if( req.readyState == 4 )
       handler( req.responseText, req.status );
  }
  // 送信
  req.send( data );
}

function addEditableMarker(id, latlng, initData) {
   var mk = new GMarker(latlng);
   map.addOverlay(mk);

  GEvent.addListener( mk, "click", function(){
    var tab1 = new GInfoWindowTab( "表示", view );
    var tab2 = new GInfoWindowTab( "編集", form );
    mk.openInfoWindowTabs( [tab1, tab2], {"maxWidth":300} );
  });

  // "表示" タブの内容
  var view = document.createElement("div");
  view.innerHTML = initData;

  // "編集" タブの内容
  var form = document.createElement("form");
    var textarea = document.createElement("textarea");
      textarea.cols = "30";
      textarea.rows = "6";
      textarea.value = initData;
    var button = document.createElement("input");
      button.type    = "button";
      button.value   = "更新";
      button.onclick = function(){ //ボタンクリック時の処理関数
        // viewの内容切り替え
        view.innerHTML = textarea.value;
        map.getInfoWindow().selectTab(0);

        // サーバーに保存
        var postdata = "data=" + encodeURIComponent(textarea.value);
        postdata += "&lat=" + encodeURIComponent(latlng.lat());
        postdata += "&lng=" + encodeURIComponent(latlng.lng());
        if( id !== undefined )
          postdata += "&id=" + encodeURIComponent(id);
        PostUrl( "write.php", postdata, function(newID){id=newID;} );
      }
    form.appendChild(textarea);
    form.appendChild(button);

  if( id === undefined )         // 新規作成マーカーは
    GEvent.trigger(mk, "click"); // クリックされたらすぐ開く
}

onload   = startUp;
onunload = GUnload;
