<?php
  ini_set( "mbstring.script_encoding", "utf-8" );
  ini_set( "default_charset", "utf-8" );
  require_once "Jsphon.php";

  // Atomフィードを読み込み
  $xml = simplexml_load_file( "http://agora.ex.nii.ac.jp/digital-typhoon/atom/ja.atom" );

  $result = array();
  foreach( $xml->entry as $entry ) {
    // Geo Vocabularyで書かれた位置情報があるエントリの場合
    $geo = $entry->children("http://www.w3.org/2003/01/geo/wgs84_pos#");
    if( $geo ) {
      $lat = (real) $geo->lat;
      $lng = (real) $geo->long;
    } else {
      unset($lat);
      unset($lng);
    }

    // （参考）GeoRSSで書かれた位置情報があるエントリの場合はこう
    //$georss = $entry->children("http://www.georss.org/georss");
    //if( $georss )
    //  list($lat,$lng) = explode(" ", $georss->point);

    if( isset($lat) && isset($lng) )
      $result[]= array(
        "title"   => (string) $entry->title,
        "content" => (string) $entry->content->children()->asXML(),
        "lat"     => (real)   $lat,
        "lng"     => (real)   $lng,
      );
  }

  // JSONに変換して出力
  print Jsphon::encode( $result );
?>
